from ctypes import * 
import tkinter as tk
from tkinter import ttk

import matplotlib
matplotlib.use('TkAgg')
from matplotlib.backends.backend_tkagg import FigureCanvasTkAgg
from matplotlib.figure import Figure


class IXUD_DEVICE_INFO(Structure):
    _fields_ = [
        ('dwSize', c_ulong),
        ('wVendorID', c_ushort),
        ('wDeviceID', c_ushort),
        ('wSubVendorID', c_ushort),
        ('wSubDeviceID', c_ushort),
        ('dwBAR', c_ulong * 6),
        ('BusNo', c_ubyte),
        ('DevNo', c_ubyte),
        ('IRQ', c_ubyte),
        ('Aux', c_ubyte),
        ('dwBarVirtualAddress', c_ulonglong * 6)
    ]
PIXUD_DEVICE_INFO = POINTER(IXUD_DEVICE_INFO)


class IXUD_CARD_INFO(Structure):
    _fields_ = [
        ('dwSize', c_ulong),
        ('dwModelNo', c_ulong),
        ('CardID', c_ubyte),
        ('wSingleEnded', c_ubyte),
        ('wAIOResolution', c_ushort),
        ('wAIChannels', c_ushort),
        ('wAOChannels', c_ushort),
        ('wDIPorts', c_ushort),
        ('wDOPorts', c_ushort),
        ('wDIOPorts', c_ushort),
        ('wDIOPortWidth', c_ushort),
        ('wCounterChannels', c_ushort),
        ('wMemorySize', c_ushort),
        ('dwReservedl', c_ulong *6)
    ]
PIXUD_CARD_INFO = POINTER(IXUD_CARD_INFO)

_wRtn = c_ushort(0)
_wTotalBoard = c_ushort(0)
sDevInfo = IXUD_DEVICE_INFO()
sCardInfo = IXUD_CARD_INFO()
ptrdev_to_struct = pointer(sDevInfo)
ptrcar_to_struct = pointer(sCardInfo)
ptrdev=[]
ptrcar=[]

fRangeMax=0
fRangeMin=0

string1 = "Modelname"
b_string1 = string1.encode('utf-8')
chan=[] 
Board=[]

keep_feeding = None
last_canvas = None
canvs=None
f=None


'''
Window size is related to screen resolution. 
Please adjust the window and its components to appropriate sizes and positions according to the screen resolution.
'''
root = tk.Tk()
root.title('Analog_Input_Polling')
root.geometry("1220x440")#Window size

dll = cdll.LoadLibrary('UniDAQ.dll')
print("Initialize and Open UniDAQ DLL")


_wRtn = dll.Ixud_DriverInit(byref(_wTotalBoard))

for i in range(0,_wTotalBoard.value):
    _wRtn = dll.Ixud_GetCardInfo(i,ptrdev_to_struct,ptrcar_to_struct,b_string1)
    string1=b_string1.decode('utf-8')
    if string1 !="0":
        Board.append(str(i)+': '+string1)
    else:
        Board.append(str(i)+': Err Device')
    ptrdev.append(ptrdev_to_struct)
    ptrcar.append(ptrcar_to_struct)


def Board_selected(event):
    global chan,ptrcar,fRangeMax,fRangeMin 
    chan=[]
    for i in range(0,ptrcar[mycombobox.current()].contents.wAIChannels):
        chan.append("Channel "+str(i))
    cbxChannel['values'] = chan
    cbxChannel.current(0)
    cbxConfig.current(0)
    fRangeMax=10
    fRangeMin=-10
    datacount.set('100')


def Config_selected(event):
    global fRangeMax,fRangeMin 
    select=cbxConfig.current()
    match select:
        case 0:
            fRangeMax=10
            fRangeMin=-10
            print('IXUD_BI_10V')
        case 1:
            fRangeMax=5
            fRangeMin=-5
            print('IXUD_BI_5V')
        case 2:
            fRangeMax = 2.5
            fRangeMin = -2.5
            print('IXUD_BI_2V5')
        case 3:
            fRangeMax = 1.25
            fRangeMin = -1.25
            print('IXUD_BI_1V25')
        case 4:
            fRangeMax = 0.625
            fRangeMin = -0.625
            print('IXUD_BI_0V625')
        case 5:
            fRangeMax = 0.3125
            fRangeMin = -0.3125
            print('IXUD_BI_0V3125')
        case 6:
            fRangeMax = 0.5
            fRangeMin = -0.5
            print('IXUD_BI_0V5')
        case 7:
            fRangeMax = 0.05
            fRangeMin = -0.05
            print('IXUD_BI_0V05')
        case 8:
            fRangeMax = 0.005
            fRangeMin = -0.005
            print('IXUD_BI_0V005')
        case 9:
            fRangeMax = 1.0
            fRangeMin = -1.0
            print('IXUD_BI_1V')
        case 10:
            fRangeMax = 0.1
            fRangeMin = -0.1
            print('IXUD_BI_0V1')
        case 11:
            fRangeMax = 0.01
            fRangeMin = -0.01
            print('IXUD_BI_0V01')
        case 12:
            fRangeMax = 0.001
            fRangeMin = -0.001
            print('IXUD_BI_0V001')
        case 13:
            fRangeMax = 20.0
            fRangeMin = 0.0
            print('IXUD_UNI_20V')
        case 14:
            fRangeMax = 10.0
            fRangeMin = 0.0
            print('IXUD_UNI_10V')
        case 15:
            fRangeMax = 5.0
            fRangeMin = 0.0
            print('IXUD_UNI_5V')
        case 16:
            fRangeMax = 2.5
            fRangeMin = 0.0
            print('IXUD_UNI_2V5')
        case 17:
            fRangeMax = 1.25
            fRangeMin = 0.0
            print('IXUD_UNI_1V25')
        case 18:
            fRangeMax = 0.625
            fRangeMin = 0.0
            print('IXUD_UNI_0V625')
        case 19:
            fRangeMax = 1.0
            fRangeMin = 0.0
            print('IXUD_UNI_1V')
        case 20:
            fRangeMax = 0.1
            fRangeMin = 0.0
            print('IXUD_UNI_0V1')
        case 21:
            fRangeMax = 0.01
            fRangeMin = 0.0
            print('IXUD_UNI_0V01')
        case 22:
            fRangeMax = 0.001
            fRangeMin = 0.0
            print('IXUD_UNI_0V001')
        case 23:
            fRangeMax = 20
            fRangeMin = -20
            print('IXUD_BI_20V')


def active_btn():
    wRtn = dll.Ixud_ConfigAI(mycombobox.current(), 2, 2048, cbxCardType.current(), 0)
    if mycombobox.current()==-1:
        print("Please select the board")
    else:
        if btn1['text']=="ACTIVE":
            btn1.config(text='STOP')
            pollai()
        else:
            btn1.config(text='ACTIVE')
            root.after_cancel(keep_feeding) #STOP 
    

def pollai():
    global keep_feeding,last_canvas
    fBuf=(c_float * int(datacount.get()))()
    xlim=(c_float * int(datacount.get()))()
    #wRtn = dll.Ixud_PollingAI(0,cbxChannel.current(),cbxConfig.current(), 100, fBuf)
    wRtn = dll.Ixud_PollingAI(mycombobox.current(),cbxChannel.current(),cbxConfig.current(), int(datacount.get()), fBuf)
    last_canvas = draw(fBuf,xlim)
    if mylistbox.size()>150:
        mylistbox.delete(100,'end')
    keep_feeding=root.after(500,pollai)


def draw(fBuf,xlim):
    global last_canvas,canvs,f
    if last_canvas:
        last_canvas.get_tk_widget().destroy()
        last_canvas=None

    for i in range(0,int(datacount.get())):
        mylistbox.insert(0, round(fBuf[i],4))
        xlim[i]=(1000/int(datacount.get()))*i

    if f :
        f.clf()#clear Figure
    if canvs: 
        canvs.get_tk_widget().pack_forget()  # remove previous image
    f_plot = f.add_subplot(111)
    canvs = FigureCanvasTkAgg(f, master=frm)
    f_plot.plot(xlim, fBuf)
    f_plot.axis([0,1000,fRangeMin,fRangeMax])
    f.tight_layout()
    canvs.draw()
    canvs.get_tk_widget().pack(side='top', fill='both', expand=1)
    
    return canvs
  
def root_destroy():
    wRtn = dll.Ixud_DriverClose()
    root.destroy()




frm = tk.Frame(root, width=10, height=10)
frm.place(x=10,y=100)
f = Figure(figsize=(12, 4), dpi=82)


tk.Label(root,text="Board",width=10,height=1).place(x=10,y=30)
comboboxText = tk.StringVar()
mycombobox = ttk.Combobox(root, textvariable=comboboxText, state='readonly')
mycombobox['values'] = Board
mycombobox.place(x=70,y=30)
mycombobox.bind('<<ComboboxSelected>>', Board_selected)


tk.Label(root,text="Range",width=10,height=1).place(x=10,y=60)
comboboxText1 = tk.StringVar()
cbxConfig = ttk.Combobox(root, textvariable=comboboxText1, state='readonly')
cbxConfig['values'] = ['00:Bipolar +/-   10.0000(V)',
'01:Bipolar +/-     5.0000(V)',
'02:Bipolar +/-     2.5000(V)',
'03:Bipolar +/-     1.2500(V)',
'04:Bipolar +/-     0.6250(V)',
'05:Bipolar +/-     0.3125(V)',
'06:Bipolar +/-     0.5000(V)',
'07:Bipolar +/-     0.0500(V)',
'08:Bipolar +/-     0.0050(V)',
'09:Bipolar +/-     1.0000(V)',
'10:Bipolar +/-     0.1000(V)',
'11:Bipolar +/-     0.0100(V)',
'12:Bipolar +/-     0.0010(V)',
'13:Unipolar 0 ~20.0000(V)',
'14:Unipolar 0 ~10.0000(V)',
'15:Unipolar 0 ~  5.0000(V)',
'16:Unipolar 0 ~  2.5000(V)',
'17:Unipolar 0 ~  1.2500(V)',
'18:Unipolar 0 ~  0.6250(V)',
'19:Unipolar 0 ~  1.0000(V)',
'20:Unipolar 0 ~  0.1000(V)',
'21:Unipolar 0 ~  0.0100(V)',
'22:Unipolar 0 ~  0.0010(V)',
'23:Bipolar +/- 20.0000(V)']
cbxConfig.place(x=70,y=60)
cbxConfig.bind('<<ComboboxSelected>>', Config_selected)


tk.Label(root,text="Channel",width=10,height=1).place(x=300,y=30)
comboboxText2 = tk.StringVar()
cbxChannel = ttk.Combobox(root, textvariable=comboboxText2, state='readonly')
cbxChannel.place(x=370,y=30)


tk.Label(root,text="Card Type",width=10,height=1).place(x=300,y=60)
comboboxText3 = tk.StringVar()
cbxCardType = ttk.Combobox(root, textvariable=comboboxText3, state='readonly')
cbxCardType['values'] = ['0:Low(	/JPx=20V)Gain','1:High(Fast/JPx=10V) Gain']
cbxCardType.current(0)
cbxCardType.place(x=370,y=60)





tk.Label(root,text="Datacount",width=10,height=1).place(x=600,y=60)
datacount= tk.StringVar()
datacount.set('')
entry_data = tk.Entry(root,textvariable=datacount)
entry_data.place(x=670,y=50,height=30,width=80)




btn1 = tk.Button(root,text="ACTIVE",command=active_btn)
btn1.place(x=800,y=30,height=50,width=50)

btnExit = tk.Button(root,text="Exit",command=root_destroy)
btnExit.place(x=860,y=30,height=50,width=50)


#The latest record is at the top.
mylistbox = tk.Listbox(root)
mylistbox.place(x=1000,y=30,height=400,width=200)




root.mainloop() 