from ctypes import * 
import tkinter as tk 
from tkinter import ttk
from PIL import Image, ImageTk 
import os


class IXUD_DEVICE_INFO(Structure):
    _fields_ = [
        ('dwSize', c_ulong),
        ('wVendorID', c_ushort),
        ('wDeviceID', c_ushort),
        ('wSubVendorID', c_ushort),
        ('wSubDeviceID', c_ushort),
        ('dwBAR', c_ulong * 6),
        ('BusNo', c_ubyte),
        ('DevNo', c_ubyte),
        ('IRQ', c_ubyte),
        ('Aux', c_ubyte),
        ('dwBarVirtualAddress', c_ulonglong * 6)
    ]
PIXUD_DEVICE_INFO = POINTER(IXUD_DEVICE_INFO)


class IXUD_CARD_INFO(Structure):
    _fields_ = [
        ('dwSize', c_ulong),
        ('dwModelNo', c_ulong),
        ('CardID', c_ubyte),
        ('wSingleEnded', c_ubyte),
        ('wAIOResolution', c_ushort),
        ('wAIChannels', c_ushort),
        ('wAOChannels', c_ushort),
        ('wDIPorts', c_ushort),
        ('wDOPorts', c_ushort),
        ('wDIOPorts', c_ushort),
        ('wDIOPortWidth', c_ushort),
        ('wCounterChannels', c_ushort),
        ('wMemorySize', c_ushort),
        ('dwReservedl', c_ulong *6)
    ]
PIXUD_CARD_INFO = POINTER(IXUD_CARD_INFO)


_wRtn = c_ushort(0)
_wTotalBoard = c_ushort(0)
sDevInfo = IXUD_DEVICE_INFO()
sCardInfo = IXUD_CARD_INFO()
DIVal=c_ulong()

ptrdev_to_struct = pointer(sDevInfo)
ptrcar_to_struct = pointer(sCardInfo)
ptrdev=[]
ptrcar=[]
DOPort=[]
DIPort=[]
Board=[]


string1 = "Modelname"
b_string1 = string1.encode('utf-8')


'''
Window size is related to screen resolution. 
Please adjust the window and its components to appropriate sizes and positions according to the screen resolution.
'''
root = tk.Tk()
root.title('Digital_IO')
root.geometry("500x200")#Window size

dll = cdll.LoadLibrary('UniDAQ.dll')
print("Initialize and Open UniDAQ DLL")

current_directory = os.getcwd()
print("The current working directory：", current_directory)



_wRtn = dll.Ixud_DriverInit(byref(_wTotalBoard))

for i in range(0,_wTotalBoard.value):
    _wRtn = dll.Ixud_GetCardInfo(i,ptrdev_to_struct,ptrcar_to_struct,b_string1)
    string1=b_string1.decode('utf-8')
    if string1 !="0":
        Board.append(str(i)+': '+string1)
    else:
        Board.append(str(i)+': Err Device')
    ptrdev.append(ptrdev_to_struct)
    ptrcar.append(ptrcar_to_struct)


def combobox_selected(event):
    global DOPort,DIPort,ptrcar
    DOPort=[]
    DIPort=[]
    for i in range(0,(ptrcar[mycombobox.current()].contents.wDIOPorts + ptrcar[mycombobox.current()].contents.wDOPorts)):
        DOPort.append('Port'+str(i))
    for i in range(0,(ptrcar[mycombobox.current()].contents.wDIOPorts + ptrcar[mycombobox.current()].contents.wDIPorts)):
        DIPort.append('Port'+str(i))
    DO_box['values'] = DOPort
    DI_box['values'] = DIPort
    DO_box.current(0)
    DI_box.current(0)


def writeText():
    
    if ptrcar[mycombobox.current()].contents.wDIOPorts > 1:
        wRtn = dll.Ixud_SetDIOMode(c_ushort(mycombobox.current()),c_ushort(DO_box.current()),c_ushort(1))
        wRtn = dll.Ixud_SetDIOMode(c_ushort(mycombobox.current()),c_ushort(DI_box.current()),c_ushort(0))

    print("get: "+num_DO.get())
    if num_DO.get()=='':
        print('Please enter a value (0~255)')
    else:
        _wRtn = dll.Ixud_WriteDO(mycombobox.current(),DO_box.current(),int(num_DO.get()))


def readText():
    if mycombobox.current()==-1:
        print("Please select the board")
    else:    
        
        _wRtn = dll.Ixud_ReadDI(mycombobox.current(),DI_box.current(),byref(DIVal))
        integer = int.from_bytes(DIVal, byteorder='little')
        tmp=str(bin(integer)).split('0b')
        num=tmp[1]
        binary(num.zfill(8))
        num_DI.set(str(integer))


def binary(num_1):
    x_place=80
    chan=7
    for i in num_1:
        if i=='1':
            tk.Label(root,text=str(chan),width=10,height=1).place(x=x_place-15,y=120) 
            tk.Label(root,image=tk_img_r,width=40,height=40,anchor='nw').place(x=x_place,y=150) 
        else:
            tk.Label(root,text=str(chan),width=10,height=1).place(x=x_place-15,y=120)    
            tk.Label(root,image=tk_img_g,width=40,height=40,anchor='nw').place(x=x_place,y=150) 
        x_place += 50
        chan -= 1
    img_red.close()
    img_gray.close()




#Board Combobox
comboboxText = tk.StringVar()
mycombobox = ttk.Combobox(root, textvariable=comboboxText, state='readonly')
mycombobox['values'] = Board
mycombobox.pack()
mycombobox.bind('<<ComboboxSelected>>', combobox_selected)


#Port Combobox
DOport_text = tk.StringVar()
DO_box= ttk.Combobox(root, textvariable=DOport_text, state='readonly', width=10)
DO_box.place(x=90,y=35)



DIport_text = tk.StringVar()
DI_box= ttk.Combobox(root, textvariable=DIport_text, state='readonly', width=10)
DI_box.place(x=90,y=70)



#DIO Entry
num_DO= tk.StringVar()
num_DI= tk.StringVar()
num_DO.set('')

entry_out = tk.Entry(root,textvariable=num_DO,justify='right').place(x=200,y=30,height=30,width=80)
tk.Label(root,text="Write DO",width=10,height=1).place(x=10,y=30)

entry_in = tk.Entry(root,textvariable=num_DI,bg="silver",state="readonly",justify='right').place(x=200,y=70,height=30,width=80)
tk.Label(root,text="Read DI",width=10,height=1).place(x=10,y=70)



#DIO Button
WriteDO_btn = tk.Button(root,text="Write DO",bd=5,command=writeText).place(x=300,y=30,height=50,width=80)
ReadDI_btn = tk.Button(root,text="Read DI",bd=5,command=readText).place(x=400,y=30,height=50,width=80)


'''
If you get FileNotFoundError, there are two ways to solve it
1. Place the image in the current working directory.
2. Please enter the absolute path of the image. For example: Image.open(r"\path\to\your\red.png")
'''

img_red = Image.open("red.png")
img_gray = Image.open("gray.png")
tk_img_r = ImageTk.PhotoImage(img_red)
tk_img_g = ImageTk.PhotoImage(img_gray)




root.mainloop()



