from ctypes import * 
import tkinter as tk 
from tkinter import ttk


class IXUD_DEVICE_INFO(Structure):
    _fields_ = [
        ('dwSize', c_ulong),
        ('wVendorID', c_ushort),
        ('wDeviceID', c_ushort),
        ('wSubVendorID', c_ushort),
        ('wSubDeviceID', c_ushort),
        ('dwBAR', c_ulong * 6),
        ('BusNo', c_ubyte),
        ('DevNo', c_ubyte),
        ('IRQ', c_ubyte),
        ('Aux', c_ubyte),
        ('dwBarVirtualAddress', c_ulonglong * 6)
    ]
PIXUD_DEVICE_INFO = POINTER(IXUD_DEVICE_INFO)


class IXUD_CARD_INFO(Structure):
    _fields_ = [
        ('dwSize', c_ulong),
        ('dwModelNo', c_ulong),
        ('CardID', c_ubyte),
        ('wSingleEnded', c_ubyte),
        ('wAIOResolution', c_ushort),
        ('wAIChannels', c_ushort),
        ('wAOChannels', c_ushort),
        ('wDIPorts', c_ushort),
        ('wDOPorts', c_ushort),
        ('wDIOPorts', c_ushort),
        ('wDIOPortWidth', c_ushort),
        ('wCounterChannels', c_ushort),
        ('wMemorySize', c_ushort),
        ('dwReservedl', c_ulong *6)
    ]
PIXUD_CARD_INFO = POINTER(IXUD_CARD_INFO)



_wRtn = c_ushort(0)
_wTotalBoard = c_ushort(0)
sDevInfo = IXUD_DEVICE_INFO()
sCardInfo = IXUD_CARD_INFO()


ptrdev_to_struct = pointer(sDevInfo)
ptrcar_to_struct = pointer(sCardInfo)
ptrdev=[]
ptrcar=[]

wBoardNo_A=c_int()
wBoardNo_B=c_int()


string1 = "Modelname"
b_string1 = string1.encode('utf-8')


'''
Window size is related to screen resolution. 
Please adjust the window and its components to appropriate sizes and positions according to the screen resolution.
'''
root = tk.Tk()
root.title('Digital_IO_By_CardID_SameCard')
root.geometry("620x490")#Window size


dll = cdll.LoadLibrary('UniDAQ.dll')
print("Initialize and Open UniDAQ DLL")

_wRtn = dll.Ixud_DriverInit(byref(_wTotalBoard))


def Card_A():
    lInputVal=c_ulong()
    #PCI1202		0x345672
   
    wRtn = dll.Ixud_GetBoardNoByCardID(byref(wBoardNo_A), int('0x345672',16) , int(Cardid_A.get()))

    if wRtn:
        print("GetBoardNoByCardID Error!!Error Code:" + str(wRtn))
    
    wRtn = dll.Ixud_WriteDO(wBoardNo_A, int(Port_A.get()), 10) #A
    wRtn = dll.Ixud_ReadDI(wBoardNo_A, int(Port_A.get()), byref(lInputVal))

    DIVHex_A.set(hex(lInputVal.value))
    Bordno_A.set(wBoardNo_A.value)

def Card_B():
    lInputVal=c_ulong()
    #PCI1202		0x345672
   
    wRtn = dll.Ixud_GetBoardNoByCardID(byref(wBoardNo_B), int('0x345672',16) , int(Cardid_B.get()))

    if wRtn:
        print("GetBoardNoByCardID Error!!Error Code:" + str(wRtn))
    
    wRtn = dll.Ixud_WriteDO(wBoardNo_B, int(Port_B.get()), 11) #B
    wRtn = dll.Ixud_ReadDI(wBoardNo_B, int(Port_B.get()), byref(lInputVal))

    DIVHex_B.set(hex(lInputVal.value))
    Bordno_B.set(wBoardNo_B.value)


def root_destroy():
    wRtn = dll.Ixud_DriverClose()
    root.destroy()

comboboxText = tk.StringVar()
message=('-----------------SETTING--------------------','','Please connect the TTL/DI and ','the TTL/DO respectively.','',
         'Adjust the CardID to 1 and 2, respectively.','','Notice:','The default settings of this demo are',
         'designed for PCI-1202.','','','','------------------RESULT---------------------','',
        'The Card-A always reads the 0x0A','no matter the "Board No" which it has.','',
        'The Card-B always reads the 0x0B ','no matter the "Board No" which it has. '          
         )
comboboxText.set(message)
message_list = tk.Listbox(root,listvariable=comboboxText,bg='lightyellow')
message_list.place(x=360,y=27,height=405,width=250)


frm_A = tk.LabelFrame(root,text='WriteDO ReadDI(PCI-1202)-A', width=350, height=200)
frm_A.place(x=10,y=20)
tk.Label(frm_A,text="Card ID",height=1).place(x=10,y=10)
tk.Label(frm_A,text="Port",height=1).place(x=10,y=50)
tk.Label(frm_A,text="DI Value(HEX)",height=1).place(x=10,y=90)
tk.Label(frm_A,text="Board No",height=1).place(x=10,y=130)

Cardid_A= tk.StringVar()
Cardid_A.set('1')
Port_A= tk.StringVar()
Port_A.set('0')
DIVHex_A= tk.StringVar()
DIVHex_A.set('0')
Bordno_A= tk.StringVar()
Bordno_A.set('')

entry_card_A = tk.Entry(frm_A,textvariable=Cardid_A,justify='right').place(x=100,y=10,height=25,width=100)
entry_port_A = tk.Entry(frm_A,textvariable=Port_A,justify='right').place(x=100,y=50,height=25,width=100)
entry_div_A = tk.Entry(frm_A,textvariable=DIVHex_A,justify='right').place(x=100,y=90,height=25,width=100)
entry_bord_A = tk.Entry(frm_A,textvariable=Bordno_A,justify='right').place(x=100,y=130,height=25,width=100)

DIO_btnA = tk.Button(frm_A,text="Write DO \n\n Read DI",bd=5,command=Card_A).place(x=230,y=5,height=150,width=100)




frm_B = tk.LabelFrame(root,text='WriteDO ReadDI(PCI-1202)-B', width=350, height=200)
frm_B.place(x=10,y=230)
tk.Label(frm_B,text="Card ID",height=1).place(x=10,y=10)
tk.Label(frm_B,text="Port",height=1).place(x=10,y=50)
tk.Label(frm_B,text="DI Value(HEX)",height=1).place(x=10,y=90)
tk.Label(frm_B,text="Board No",height=1).place(x=10,y=130)

Cardid_B= tk.StringVar()
Cardid_B.set('2')
Port_B= tk.StringVar()
Port_B.set('0')
DIVHex_B= tk.StringVar()
DIVHex_B.set('0')
Bordno_B= tk.StringVar()
Bordno_B.set('')

entry_card_B = tk.Entry(frm_B,textvariable=Cardid_B,justify='right').place(x=100,y=10,height=25,width=100)
entry_port_B = tk.Entry(frm_B,textvariable=Port_B,justify='right').place(x=100,y=50,height=25,width=100)
entry_div_B = tk.Entry(frm_B,textvariable=DIVHex_B,justify='right').place(x=100,y=90,height=25,width=100)
entry_bord_B = tk.Entry(frm_B,textvariable=Bordno_B,justify='right').place(x=100,y=130,height=25,width=100)

DIO_btnB = tk.Button(frm_B,text="Write DO \n\n Read DI",bd=5,command=Card_B).place(x=230,y=5,height=150,width=100)


btnExit = tk.Button(root,text="Exit",bd=3,command=root_destroy)
btnExit.place(x=10,y=430,height=50,width=600)
    
root.mainloop()